MCP Tools Reference: home.googleapis.com

Tool: list_home_history

Retrieves the history for home resources including devices.

The following code sample shows how to use curl to call the list_home_history MCP tool.

Curl Request
curl --location 'https://home.googleapis.com/mcp' \
--header 'Authorization: Bearer {oauth-access-token}' \
--header 'content-type: application/json' \
--header 'accept: application/json, text/event-stream' \
--data '{
  "method": "tools/call",
  "params": {
    "name": "list_home_history",
    "arguments": {
      // Provide these details according to the MCP tool specification.
    }
  },
  "jsonrpc": "2.0",
  "id": 1
}'

Input Schema

Request for RetrieveHomeHistory.

RetrieveHomeHistoryRequest

JSON representation
{
  "structureId": string,
  "filter": {
    object (Filter)
  },
  "startTime": string,
  "endTime": string,
  "includeMediaUrls": boolean,
  "outputFormat": enum (OutputFormat),
  "pageToken": string
}
Fields
structureId

string

Required. The HomeGraph structure_id to retrieve history for.

filter

object (Filter)

Optional. An optional filter for the history entries.

startTime

string (Timestamp format)

Optional. The time to start event history from. Includes entries at specified time.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

endTime

string (Timestamp format)

Optional. The time to end event history at. Excludes entries at specified time.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

includeMediaUrls

boolean

Optional. If true, include media URLs in camera events.

outputFormat

enum (OutputFormat)

Optional. The desired output format for history. If not set, defaults to OUTPUT_FORMAT_PROTO for backwards compatibility.

pageToken

string

Optional. A page token, received from a previous RetrieveHomeHistory call. Provide this to retrieve the subsequent page. The filter used for the originating call must be reused.

Filter

JSON representation
{
  "resourceIds": [
    string
  ],
  "shortenedResourceTypes": [
    string
  ],
  "shortenedResourceTraits": [
    string
  ],
  "shortenedResourceEvents": [
    string
  ],
  "fieldPaths": [
    string
  ]
}
Fields
resourceIds[]

string

Optional. The resource id for filtering. (e.g. device@device_id, automation@automation_id)

shortenedResourceTypes[]

string

Optional. The resource types to filter resources by. Example: "GoogleLightDevice", "GoogleDisplayDevice", "SpeakerDevice", "VideoRemoteControlDevice" (and not "action.devices.types.LIGHT"). Not case sensitive.

shortenedResourceTraits[]

string

Optional. The resource traits to filter resources by. Component prefixes should not be included and should be specified in the shortened_resource_types field instead. Example: "OnOff", "Volume" (and not either "home.uddm.traits.matter.OnOffTrait" or "GoogleTvDevice/OnOff"). Not case sensitive.

shortenedResourceEvents[]

string

Optional. The resource events to filter history events by. Must be in "TraitName.EventName" format (e.g. CameraHistory.HistoryItem). Should not be prefixed by component name. Not case sensitive.

fieldPaths[]

string

Optional. Paths to filter by. These are case sensitive. Traits and events should be properly PascalCased and fields should be camelCased.

Format: - For traits: "[Trait].[fieldPath]" - For events: "[Trait].[Event].[fieldPath]"

Examples: - "OnOff.onOff" (or "OnOff.state.onOff") - "CameraHistory.HistoryItem.eventTracks.zones"

For the path filter to take effect, the trait or event type must also be specified in shortened_resource_traits or shortened_resource_events respectively.

Timestamp

JSON representation
{
  "seconds": string,
  "nanos": integer
}
Fields
seconds

string (int64 format)

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z).

nanos

integer

Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive.

OutputFormat

The desired output format.

Enums
OUTPUT_FORMAT_UNSPECIFIED Defaults to OUTPUT_FORMAT_PROTO for backwards compatibility.
OUTPUT_FORMAT_PROTO Returns the response as a proto.
OUTPUT_FORMAT_TSV Returns the response as a TSV formatted string. The first row describes the fields and the following rows are the data.

Output Schema

Response for RetrieveHomeHistory.

RetrieveHomeHistoryResponse

JSON representation
{
  "nextPageToken": string,

  // Union field output can be only one of the following:
  "entries": {
    object (HomeHistoryEntries)
  },
  "tsvHistoryText": string
  // End of list of possible types for union field output.
}
Fields
nextPageToken

string

A page token, received from a previous RetrieveHomeHistory call. Provide this to retrieve the subsequent page. If empty, there are no subsequent pages.

Union field output. One of the following fields will be set based on the requested output format. output can be only one of the following:
entries

object (HomeHistoryEntries)

The list of home history entries associated with the structure.

tsvHistoryText

string

TSV formatted string of home history entries.

HomeHistoryEntries

JSON representation
{
  "entries": [
    {
      object (HomeHistoryEntry)
    }
  ]
}
Fields
entries[]

object (HomeHistoryEntry)

The list of home history entries associated with the structure.

HomeHistoryEntry

JSON representation
{
  "eventId": string,
  "timestamp": string,
  "resourceId": string,
  "resourceType": string,
  "resourceName": string,
  "attribution": {
    object (Attribution)
  },
  "observationType": enum (ObservationType),

  // Union field history_entry can be only one of the following:
  "resourceStateChange": {
    object (ResourceState)
  },
  "event": {
    object (HistoryEvent)
  }
  // End of list of possible types for union field history_entry.
}
Fields
eventId

string

Output only. The unique identifier of the home history entry.

timestamp

string (Timestamp format)

Output only. The timestamp at which the history entry was recorded.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

resourceId

string

Output only. The unique, server-assigned resource name of the device. This field is immutable and should be used as the primary identifier. Format: device@device_id

resourceType

string

Output only. The normalized high-level type of the device (e.g., "light", "thermostat").

resourceName

string

Output only. The user-friendly, mutable name of the device (e.g., "Living Room Lamp").

attribution

object (Attribution)

Output only. Attribution details for an entry in Home History.

observationType

enum (ObservationType)

Output only. Indicates whether the state update or event was proactively reported in real-time by the device/partner or queried (polled) by Google.

Union field history_entry. The type of the history entry. history_entry can be only one of the following:
resourceStateChange

object (ResourceState)

Output only. The resource state change event.

event

object (HistoryEvent)

Output only. The event that occurred.

Timestamp

JSON representation
{
  "seconds": string,
  "nanos": integer
}
Fields
seconds

string (int64 format)

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z).

nanos

integer

Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive.

ResourceState

JSON representation
{
  "id": string,
  "type": string,
  "displayName": string,
  "traits": {
    string: {
      object (TraitState)
    },
    ...
  },
  "resourceConnectivityState": enum (ConnectivityState),
  "timestamp": string
}
Fields
id

string

Identifier. The unique identifier for the resource (e.g. device@device_id, scene@scene_id, automation@automation_id, room@room_id, etc.).

type

string

Output only. The type of the resource.

displayName

string

Output only. The display name of the resource.

traits

map (key: string, value: object (TraitState))

Output only. The state of each trait on the resource, keyed by the trait name (e.g. OnOff, Volume).

An object containing a list of "key": value pairs. Example: { "name": "wrench", "mass": "1.3kg", "count": "3" }.

resourceConnectivityState

enum (ConnectivityState)

Output only. The connectivity status of a home resource.

timestamp

string (Timestamp format)

Output only. The timestamp at which the resource state was recorded. For state retrieval, it is the timestamp at which the state was observed.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

TraitsEntry

JSON representation
{
  "key": string,
  "value": {
    object (TraitState)
  }
}
Fields
key

string

value

object (TraitState)

TraitState

JSON representation
{
  "type": string,
  "connectivityState": enum (ConnectivityState),
  "stateReportingOmitted": boolean,
  "state": {
    object
  },
  "timestamp": string
}
Fields
type

string

Output only. The type that this trait applies to.

connectivityState

enum (ConnectivityState)

Output only. The connectivity status of the trait.

stateReportingOmitted

boolean

Output only. Whether the state reporting is omitted for this trait.

state

object (Struct format)

Output only. The state of the trait.

timestamp

string (Timestamp format)

Output only. The timestamp at which the event happened.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

Struct

JSON representation
{
  "fields": {
    string: value,
    ...
  }
}
Fields
fields

map (key: string, value: value (Value format))

Unordered map of dynamically typed values.

An object containing a list of "key": value pairs. Example: { "name": "wrench", "mass": "1.3kg", "count": "3" }.

FieldsEntry

JSON representation
{
  "key": string,
  "value": value
}
Fields
key

string

value

value (Value format)

Value

JSON representation
{

  // Union field kind can be only one of the following:
  "nullValue": null,
  "numberValue": number,
  "stringValue": string,
  "boolValue": boolean,
  "structValue": {
    object
  },
  "listValue": array
  // End of list of possible types for union field kind.
}
Fields
Union field kind. The kind of value. kind can be only one of the following:
nullValue

null

Represents a JSON null.

numberValue

number

Represents a JSON number. Must not be NaN, Infinity or -Infinity, since those are not supported in JSON. This also cannot represent large Int64 values, since JSON format generally does not support them in its number type.

stringValue

string

Represents a JSON string.

boolValue

boolean

Represents a JSON boolean (true or false literal in JSON).

structValue

object (Struct format)

Represents a JSON object.

listValue

array (ListValue format)

Represents a JSON array.

ListValue

JSON representation
{
  "values": [
    value
  ]
}
Fields
values[]

value (Value format)

Repeated field of dynamically typed values.

HistoryEvent

JSON representation
{
  "eventType": string,
  "event": {
    object
  }
}
Fields
eventType

string

Output only. The type of the event. Example: "AreaAttendanceState.AttendanceStateChange"

event

object (Struct format)

Output only. Struct containing the trait keys and values for the event. Example: "onOff": true or "currentLevel": 254

Attribution

JSON representation
{
  "user": {
    object (UserIdentity)
  },
  "actor": {
    object (Actor)
  },
  "application": {
    object (Application)
  }
}
Fields
user

object (UserIdentity)

The user whose credential was used to perform the action.

actor

object (Actor)

The actual (non-user) entity/service that performed the action.

application

object (Application)

The application used to perform the action.

UserIdentity

JSON representation
{

  // Union field identity can be only one of the following:
  "userId": string
  // End of list of possible types for union field identity.
}
Fields
Union field identity. The identity of the user. identity can be only one of the following:
userId

string

Google User ID of the user. This is the same ID returned in StructureUserManagementTrait.

Actor

JSON representation
{
  "displayName": string,
  "automation": {
    object (Automation)
  },
  "agent": {
    object (Agent)
  }
}
Fields
displayName

string

Display name of the actor. For automation actors, this is the automation name. For agent actors, this will likely be empty.

automation

object (Automation)

The automation that triggered the action.

agent

object (Agent)

The AI agent that triggered the action.

Automation

JSON representation
{
  "automationId": string,
  "creatorUser": {
    object (UserIdentity)
  },
  "creatorAgent": {
    object (Agent)
  }
}
Fields
automationId

string

The unique ID of the automation instance (e.g. automation@).

creatorUser

object (UserIdentity)

The identity that created the automation. Note: This reflects the creator at the time the automation was made, who may no longer be a part of the structure.

creatorAgent

object (Agent)

The agent that created the automation. Can be empty if the automation was created by a user directly.

Agent

JSON representation
{
  "agentId": string
}
Fields
agentId

string

A unique identifier for the agent (e.g. SWAYAM_AGENT).

Application

JSON representation
{
  "applicationId": string,
  "displayName": string
}
Fields
applicationId

string

The application ID used to perform the action.

displayName

string

The human-readable display name of the application.

ConnectivityState

The connectivity status of a home resource or trait.

Enums
CONNECTIVITY_STATE_UNSPECIFIED The default value. This value is used if the connectivity status is omitted.
UNKNOWN The connectivity status is unknown.
ONLINE The connectivity status is online.
OFFLINE The connectivity status is offline.
PARTIAL_ONLINE The resource is partially online, meaning some of its underlying functionalities are online.

NullValue

Represents a JSON null.

NullValue is a sentinel, using an enum with only one value to represent the null value for the Value type union.

A field of type NullValue with any value other than 0 is considered invalid. Most ProtoJSON serializers will emit a Value with a null_value set as a JSON null regardless of the integer value, and so will round trip to a 0 value.

Enums
NULL_VALUE Null value.

ObservationType

Represents how a state change or event was observed.

Enums
OBSERVATION_TYPE_UNSPECIFIED The observation type is unspecified or unknown.
REPORTED The state update or event was proactively reported in real-time by the device or partner cloud when it occurred.
QUERIED The state was queried (polled) by Google (e.g. periodic background poll, sync, or 3P query), so the change might not have necessarily occurred at this timestamp.

Tool Annotations

Tool annotations are sent to MCP clients to describe the basic risk of a given tool. Most clients treat these hints as untrusted, but they can be used to decide when a confirmation prompt might be sent to a user.

Along with the title string, the following boolean hints are defined as follows:

  • readOnlyHint: If true, the tool doesn't modify its environment. Default: false.
  • destructiveHint: If true, then the tool can perform destructive actions. If false, then the tool can only perform additive actions. Default: true.
  • idempotentHint: If true, then calling the tool repeatedly with the same arguments will have no additional effect on its environment. Default: false.
  • openWorldHint: If true, then the tool can interact with an 'open world' of external entities. If false, then the tool can only interact with internal entities. For example, a web search tool would be open world, while a memory tool would not be open world.

Destructive Hint: ❌ | Idempotent Hint: ✅ | Read Only Hint: ✅ | Open World Hint: ✅